/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.187 Revision 1.218
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.187 2005/07/06 20:23:20 agriffis Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.218 2005/11/22 11:15:34 flameeyes Exp $
4# 4#
5# Author: Martin Schlemmer <azarah@gentoo.org> 5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 6#
7# This eclass is for general purpose functions that most ebuilds 7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 8# have to implement themselves.
9# 9#
10# NB: If you add anything, please comment it! 10# NB: If you add anything, please comment it!
11 11
12inherit multilib 12inherit multilib portability
13 13
14DEPEND="!bootstrap? ( sys-devel/patch )" 14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745. 15# sys-apps/shadow is needed for useradd, etc, bug #94745.
16 16
17DESCRIPTION="Based on the ${ECLASS} eclass" 17DESCRIPTION="Based on the ${ECLASS} eclass"
67 dodir /usr/${libdir} 67 dodir /usr/${libdir}
68 68
69 for lib in "${@}" ; do 69 for lib in "${@}" ; do
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
71 /* GNU ld script 71 /* GNU ld script
72 Since Gentoo has critical dynamic libraries 72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib, 73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib, 74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems. 75 otherwise we run into linking problems.
76 76
77 See bug http://bugs.gentoo.org/4411 for more info. 77 See bug http://bugs.gentoo.org/4411 for more info.
78 */ 78 */
79 GROUP ( /${libdir}/${lib} ) 79 GROUP ( /${libdir}/${lib} )
80 END_LDSCRIPT 80 END_LDSCRIPT
81 fperms a+x "/usr/${libdir}/${lib}" 81 fperms a+x "/usr/${libdir}/${lib}"
166# hand its a directory, it will set EPATCH_SOURCE to this. 166# hand its a directory, it will set EPATCH_SOURCE to this.
167# 167#
168# <azarah@gentoo.org> (10 Nov 2002) 168# <azarah@gentoo.org> (10 Nov 2002)
169# 169#
170epatch() { 170epatch() {
171 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
171 local PIPE_CMD="" 172 local PIPE_CMD=""
172 local STDERR_TARGET="${T}/$$.out" 173 local STDERR_TARGET="${T}/$$.out"
173 local PATCH_TARGET="${T}/$$.patch" 174 local PATCH_TARGET="${T}/$$.patch"
174 local PATCH_SUFFIX="" 175 local PATCH_SUFFIX=""
175 local SINGLE_PATCH="no" 176 local SINGLE_PATCH="no"
176 local x="" 177 local x=""
178
179 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
177 180
178 if [ "$#" -gt 1 ] 181 if [ "$#" -gt 1 ]
179 then 182 then
180 local m="" 183 local m=""
181 for m in "$@" ; do 184 for m in "$@" ; do
311 count=5 314 count=5
312 break 315 break
313 fi 316 fi
314 fi 317 fi
315 318
316 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 319 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
317 then 320 then
318 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 321 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 322 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
320 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 323 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 324 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 325 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 326
324 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 327 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
328 _epatch_assert
325 329
326 if [ "$?" -ne 0 ] 330 if [ "$?" -ne 0 ]
327 then 331 then
328 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 332 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
329 echo 333 echo
375# vapier@gentoo.org 379# vapier@gentoo.org
376# 380#
377# Takes just 1 optional parameter (the directory to create tmpfile in) 381# Takes just 1 optional parameter (the directory to create tmpfile in)
378emktemp() { 382emktemp() {
379 local exe="touch" 383 local exe="touch"
380 [ "$1" == "-d" ] && exe="mkdir" && shift 384 [[ $1 == -d ]] && exe="mkdir" && shift
381 local topdir="$1" 385 local topdir=$1
382 386
383 if [ -z "${topdir}" ] 387 if [[ -z ${topdir} ]] ; then
384 then
385 [ -z "${T}" ] \ 388 [[ -z ${T} ]] \
386 && topdir="/tmp" \ 389 && topdir="/tmp" \
387 || topdir="${T}" 390 || topdir=${T}
388 fi 391 fi
389 392
390 if [ -z "$(type -p mktemp)" ] 393 if [[ -z $(type -p mktemp) ]] ; then
391 then
392 local tmp=/ 394 local tmp=/
393 while [ -e "${tmp}" ] ; do 395 while [[ -e ${tmp} ]] ; do
394 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}" 396 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
395 done 397 done
396 ${exe} "${tmp}" 398 ${exe} "${tmp}" || ${exe} -p "${tmp}"
397 echo "${tmp}" 399 echo "${tmp}"
398 else 400 else
399 [ "${exe}" == "touch" ] \ 401 [[ ${exe} == "touch" ]] \
400 && exe="-p" \ 402 && exe="-p" \
401 || exe="-d" 403 || exe="-d"
402 mktemp ${exe} "${topdir}" 404 mktemp ${exe} "${topdir}"
403 fi 405 fi
404} 406}
408# Joe Jezak <josejx@gmail.com> and usata@gentoo.org 410# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
409# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org> 411# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
410# 412#
411# egetent(database, key) 413# egetent(database, key)
412egetent() { 414egetent() {
413 if [[ "${USERLAND}" == "Darwin" ]] ; then 415 case ${CHOST} in
416 *-darwin*)
414 case "$2" in 417 case "$2" in
415 *[!0-9]*) # Non numeric 418 *[!0-9]*) # Non numeric
416 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 419 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
417 ;; 420 ;;
418 *) # Numeric 421 *) # Numeric
419 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 422 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
420 ;; 423 ;;
421 esac 424 esac
422 elif [[ "${USERLAND}" == "BSD" ]] ; then 425 ;;
423 local action 426 *-freebsd*)
424 if [ "$1" == "passwd" ] 427 local opts action="user"
425 then 428 [[ $1 == "passwd" ]] || action="group"
426 action="user" 429
427 else 430 # lookup by uid/gid
428 action="group" 431 if [[ $2 == [[:digit:]]* ]] ; then
432 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
429 fi 433 fi
434
430 pw show "${action}" "$2" -q 435 pw show ${action} ${opts} "$2" -q
431 else 436 ;;
437 *-netbsd*|*-openbsd*)
438 grep "$2:\*:" /etc/$1
439 ;;
440 *)
432 which nscd >& /dev/null && nscd -i "$1" 441 type -p nscd >& /dev/null && nscd -i "$1"
433 getent "$1" "$2" 442 getent "$1" "$2"
434 fi 443 ;;
444 esac
435} 445}
436 446
437# Simplify/standardize adding users to the system 447# Simplify/standardize adding users to the system
438# vapier@gentoo.org 448# vapier@gentoo.org
439# 449#
477 fi 487 fi
478 else 488 else
479 euid="next" 489 euid="next"
480 fi 490 fi
481 if [[ ${euid} == "next" ]] ; then 491 if [[ ${euid} == "next" ]] ; then
482 local pwrange 492 for euid in $(seq 101 999) ; do
483 if [[ ${USERLAND} == "BSD" ]] ; then
484 pwrange=$(jot 898 101)
485 else
486 pwrange=$(seq 101 999)
487 fi
488 for euid in ${pwrange} ; do
489 [[ -z $(egetent passwd ${euid}) ]] && break 493 [[ -z $(egetent passwd ${euid}) ]] && break
490 done 494 done
491 fi 495 fi
492 opts="${opts} -u ${euid}" 496 opts="${opts} -u ${euid}"
493 einfo " - Userid: ${euid}" 497 einfo " - Userid: ${euid}"
498 if [[ ! -e ${eshell} ]] ; then 502 if [[ ! -e ${eshell} ]] ; then
499 eerror "A shell was specified but it does not exist !" 503 eerror "A shell was specified but it does not exist !"
500 die "${eshell} does not exist" 504 die "${eshell} does not exist"
501 fi 505 fi
502 else 506 else
503 case ${USERLAND} in 507 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
504 Darwin) eshell="/usr/bin/false";; 508 [[ -x ${ROOT}${shell} ]] && break
505 BSD) eshell="/usr/sbin/nologin";; 509 done
506 *) eshell="/bin/false";; 510
507 esac 511 if [[ ${shell} == "/dev/null" ]] ; then
512 eerror "Unable to identify the shell to use"
513 die "Unable to identify the shell to use"
514 fi
515
516 eshell=${shell}
508 fi 517 fi
509 einfo " - Shell: ${eshell}" 518 einfo " - Shell: ${eshell}"
510 opts="${opts} -s ${eshell}" 519 opts="${opts} -s ${eshell}"
511 520
512 # handle homedir 521 # handle homedir
549 einfo " - Groups: ${egroups}" 558 einfo " - Groups: ${egroups}"
550 559
551 # handle extra and add the user 560 # handle extra and add the user
552 local oldsandbox=${SANDBOX_ON} 561 local oldsandbox=${SANDBOX_ON}
553 export SANDBOX_ON="0" 562 export SANDBOX_ON="0"
554 case ${USERLAND} in 563 case ${CHOST} in
555 Darwin) 564 *-darwin*)
556 ### Make the user 565 ### Make the user
557 if [[ -z $@ ]] ; then 566 if [[ -z $@ ]] ; then
558 dscl . create /users/${euser} uid ${euid} 567 dscl . create /users/${euser} uid ${euid}
559 dscl . create /users/${euser} shell ${eshell} 568 dscl . create /users/${euser} shell ${eshell}
560 dscl . create /users/${euser} home ${ehome} 569 dscl . create /users/${euser} home ${ehome}
571 einfo "Please report the ebuild along with the info below" 580 einfo "Please report the ebuild along with the info below"
572 einfo "eextra: $@" 581 einfo "eextra: $@"
573 die "Required function missing" 582 die "Required function missing"
574 fi 583 fi
575 ;; 584 ;;
576 BSD) 585 *-freebsd*)
577 if [[ -z $@ ]] ; then 586 if [[ -z $@ ]] ; then
578 pw useradd ${euser} ${opts} \ 587 pw useradd ${euser} ${opts} \
579 -c "added by portage for ${PN}" \ 588 -c "added by portage for ${PN}" \
580 die "enewuser failed" 589 die "enewuser failed"
581 else 590 else
582 einfo " - Extra: $@" 591 einfo " - Extra: $@"
583 pw useradd ${euser} ${opts} \ 592 pw useradd ${euser} ${opts} \
584 "$@" || die "enewuser failed" 593 "$@" || die "enewuser failed"
585 fi 594 fi
586 ;; 595 ;;
596
597 *-netbsd*)
598 if [[ -z $@ ]] ; then
599 useradd ${opts} ${euser} || die "enewuser failed"
600 else
601 einfo " - Extra: $@"
602 useradd ${opts} ${euser} "$@" || die "enewuser failed"
603 fi
604 ;;
605
606 *-openbsd*)
607 if [[ -z $@ ]] ; then
608 useradd -u ${euid} -s ${eshell} \
609 -d ${ehome} -c "Added by portage for ${PN}" \
610 -g ${egroups} ${euser} || die "enewuser failed"
611 else
612 einfo " - Extra: $@"
613 useradd -u ${euid} -s ${eshell} \
614 -d ${ehome} -c "Added by portage for ${PN}" \
615 -g ${egroups} ${euser} "$@" || die "enewuser failed"
616 fi
617 ;;
618
587 *) 619 *)
588 if [[ -z $@ ]] ; then 620 if [[ -z $@ ]] ; then
589 useradd ${opts} ${euser} \ 621 useradd ${opts} ${euser} \
590 -c "added by portage for ${PN}" \ 622 -c "added by portage for ${PN}" \
591 || die "enewuser failed" 623 || die "enewuser failed"
594 useradd ${opts} ${euser} "$@" \ 626 useradd ${opts} ${euser} "$@" \
595 || die "enewuser failed" 627 || die "enewuser failed"
596 fi 628 fi
597 ;; 629 ;;
598 esac 630 esac
631
632 if [[ ! -e ${ROOT}/${ehome} ]] ; then
633 einfo " - Creating ${ehome} in ${ROOT}"
634 mkdir -p "${ROOT}/${ehome}"
635 chown ${euser} "${ROOT}/${ehome}"
636 chmod 755 "${ROOT}/${ehome}"
637 fi
638
599 export SANDBOX_ON=${oldsandbox} 639 export SANDBOX_ON=${oldsandbox}
600
601 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
602 then
603 einfo " - Creating ${ehome} in ${D}"
604 dodir ${ehome}
605 fowners ${euser} ${ehome}
606 fperms 755 ${ehome}
607 fi
608} 640}
609 641
610# Simplify/standardize adding groups to the system 642# Simplify/standardize adding groups to the system
611# vapier@gentoo.org 643# vapier@gentoo.org
612# 644#
641 then 673 then
642 if [ "${egid}" -gt 0 ] 674 if [ "${egid}" -gt 0 ]
643 then 675 then
644 if [ -z "`egetent group ${egid}`" ] 676 if [ -z "`egetent group ${egid}`" ]
645 then 677 then
646 if [[ "${USERLAND}" == "Darwin" ]]; then 678 if [[ "${CHOST}" == *-darwin* ]]; then
647 opts="${opts} ${egid}" 679 opts="${opts} ${egid}"
648 else 680 else
649 opts="${opts} -g ${egid}" 681 opts="${opts} -g ${egid}"
650 fi 682 fi
651 else 683 else
665 opts="${opts} ${eextra}" 697 opts="${opts} ${eextra}"
666 698
667 # add the group 699 # add the group
668 local oldsandbox="${SANDBOX_ON}" 700 local oldsandbox="${SANDBOX_ON}"
669 export SANDBOX_ON="0" 701 export SANDBOX_ON="0"
670 if [[ "${USERLAND}" == "Darwin" ]]; then 702 case ${CHOST} in
703 *-darwin*)
671 if [ ! -z "${eextra}" ]; 704 if [ ! -z "${eextra}" ];
672 then 705 then
673 einfo "Extra options are not supported on Darwin/OS X yet" 706 einfo "Extra options are not supported on Darwin/OS X yet"
674 einfo "Please report the ebuild along with the info below" 707 einfo "Please report the ebuild along with the info below"
675 einfo "eextra: ${eextra}" 708 einfo "eextra: ${eextra}"
676 die "Required function missing" 709 die "Required function missing"
677 fi 710 fi
678 711
679 # If we need the next available 712 # If we need the next available
680 case ${egid} in 713 case ${egid} in
681 *[!0-9]*) # Non numeric 714 *[!0-9]*) # Non numeric
682 for egid in `jot 898 101`; do 715 for egid in $(seq 101 999); do
683 [ -z "`egetent group ${egid}`" ] && break 716 [ -z "`egetent group ${egid}`" ] && break
684 done 717 done
685 esac 718 esac
686 dscl . create /groups/${egroup} gid ${egid} 719 dscl . create /groups/${egroup} gid ${egid}
687 dscl . create /groups/${egroup} passwd '*' 720 dscl . create /groups/${egroup} passwd '*'
688 elif [[ "${USERLAND}" == "BSD" ]] ; then 721 ;;
722
723 *-freebsd*)
689 case ${egid} in 724 case ${egid} in
690 *[!0-9]*) # Non numeric 725 *[!0-9]*) # Non numeric
691 for egid in `jot 898 101`; do 726 for egid in $(seq 101 999); do
692 [ -z "`egetent group ${egid}`" ] && break 727 [ -z "`egetent group ${egid}`" ] && break
693 done 728 done
694 esac 729 esac
695 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 730 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
696 else 731 ;;
732
733 *-netbsd*)
734 case ${egid} in
735 *[!0-9]*) # Non numeric
736 for egid in $(seq 101 999); do
737 [ -z "`egetent group ${egid}`" ] && break
738 done
739 esac
740 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
741 ;;
742
743 *)
697 groupadd ${opts} ${egroup} || die "enewgroup failed" 744 groupadd ${opts} ${egroup} || die "enewgroup failed"
698 fi 745 ;;
746 esac
699 export SANDBOX_ON="${oldsandbox}" 747 export SANDBOX_ON="${oldsandbox}"
700} 748}
701 749
702# Simple script to replace 'dos2unix' binaries 750# Simple script to replace 'dos2unix' binaries
703# vapier@gentoo.org 751# vapier@gentoo.org
728# name: the name that will show up in the menu 776# name: the name that will show up in the menu
729# icon: give your little like a pretty little icon ... 777# icon: give your little like a pretty little icon ...
730# this can be relative (to /usr/share/pixmaps) or 778# this can be relative (to /usr/share/pixmaps) or
731# a full path to an icon 779# a full path to an icon
732# type: what kind of application is this ? for categories: 780# type: what kind of application is this ? for categories:
733# http://www.freedesktop.org/wiki/Standards_2fmenu_2dspec 781# http://www.freedesktop.org/Standards/desktop-entry-spec
734# path: if your app needs to startup in a specific dir 782# path: if your app needs to startup in a specific dir
735make_desktop_entry() { 783make_desktop_entry() {
736 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 784 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1
737 785
738 local exec=${1} 786 local exec=${1}
764 dev) 812 dev)
765 type="Development" 813 type="Development"
766 ;; 814 ;;
767 815
768 games) 816 games)
769 [[ -z ${path} ]] && path=${GAMES_BINDIR}
770
771 case ${catmin} in 817 case ${catmin} in
772 action) type=ActionGame;; 818 action) type=ActionGame;;
773 arcade) type=ArcadeGame;; 819 arcade) type=ArcadeGame;;
774 board) type=BoardGame;; 820 board) type=BoardGame;;
775 kid) type=KidsGame;; 821 kid) type=KidsGame;;
816 type="Network;${type}" 862 type="Network;${type}"
817 ;; 863 ;;
818 864
819 sci) 865 sci)
820 case ${catmin} in 866 case ${catmin} in
821 astro*) type=Astronomoy;; 867 astro*) type=Astronomy;;
822 bio*) type=Biology;; 868 bio*) type=Biology;;
823 calc*) type=Calculator;; 869 calc*) type=Calculator;;
824 chem*) type=Chemistry;; 870 chem*) type=Chemistry;;
825 geo*) type=Geology;; 871 geo*) type=Geology;;
826 math*) type=Math;; 872 math*) type=Math;;
858Exec=${exec} 904Exec=${exec}
859Path=${path} 905Path=${path}
860Icon=${icon} 906Icon=${icon}
861Categories=Application;${type};" > "${desktop}" 907Categories=Application;${type};" > "${desktop}"
862 908
909 (
910 # wrap the env here so that the 'insinto' call
911 # doesn't corrupt the env of the caller
863 insinto /usr/share/applications 912 insinto /usr/share/applications
864 doins "${desktop}" 913 doins "${desktop}"
865 914 )
866 return 0
867} 915}
868 916
869# Make a GDM/KDM Session file 917# Make a GDM/KDM Session file
870# 918#
871# make_desktop_entry(<title>, <command>) 919# make_desktop_entry(<title>, <command>)
900 doins "${i}" 948 doins "${i}"
901 elif [[ -d ${i} ]] ; then 949 elif [[ -d ${i} ]] ; then
902 for j in "${i}"/*.desktop ; do 950 for j in "${i}"/*.desktop ; do
903 doins "${j}" 951 doins "${j}"
904 done 952 done
905 fi 953 fi
906 done 954 done
907} 955}
908newmenu() { 956newmenu() {
909 insinto /usr/share/applications 957 insinto /usr/share/applications
910 newins "$1" "$2" 958 newins "$1" "$2"
918 doins "${i}" 966 doins "${i}"
919 elif [[ -d ${i} ]] ; then 967 elif [[ -d ${i} ]] ; then
920 for j in "${i}"/*.png ; do 968 for j in "${i}"/*.png ; do
921 doins "${j}" 969 doins "${j}"
922 done 970 done
923 fi 971 fi
924 done 972 done
925} 973}
926newicon() { 974newicon() {
927 insinto /usr/share/pixmaps 975 insinto /usr/share/pixmaps
928 newins "$1" "$2" 976 newins "$1" "$2"
933############################################################## 981##############################################################
934 982
935 983
936# for internal use only (unpack_pdv and unpack_makeself) 984# for internal use only (unpack_pdv and unpack_makeself)
937find_unpackable_file() { 985find_unpackable_file() {
938 local src="$1" 986 local src=$1
939 if [ -z "${src}" ] 987 if [[ -z ${src} ]] ; then
940 then
941 src="${DISTDIR}/${A}" 988 src=${DISTDIR}/${A}
942 else 989 else
943 if [ -e "${DISTDIR}/${src}" ] 990 if [[ -e ${DISTDIR}/${src} ]] ; then
944 then
945 src="${DISTDIR}/${src}" 991 src=${DISTDIR}/${src}
946 elif [ -e "${PWD}/${src}" ] 992 elif [[ -e ${PWD}/${src} ]] ; then
947 then
948 src="${PWD}/${src}" 993 src=${PWD}/${src}
949 elif [ -e "${src}" ] 994 elif [[ -e ${src} ]] ; then
950 then
951 src="${src}" 995 src=${src}
952 fi
953 fi 996 fi
954 [ ! -e "${src}" ] && die "Could not find requested archive ${src}" 997 fi
998 [[ ! -e ${src} ]] && return 1
955 echo "${src}" 999 echo "${src}"
956} 1000}
957 1001
958# Unpack those pesky pdv generated files ... 1002# Unpack those pesky pdv generated files ...
959# They're self-unpacking programs with the binary package stuffed in 1003# They're self-unpacking programs with the binary package stuffed in
974# lseek 1018# lseek
975# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1019# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
976# lseek(3, -4, SEEK_END) = 2981250 1020# lseek(3, -4, SEEK_END) = 2981250
977# thus we would pass in the value of '4' as the second parameter. 1021# thus we would pass in the value of '4' as the second parameter.
978unpack_pdv() { 1022unpack_pdv() {
979 local src="`find_unpackable_file $1`" 1023 local src=$(find_unpackable_file $1)
980 local sizeoff_t="$2" 1024 local sizeoff_t=$2
981 1025
1026 [[ -z ${src} ]] && die "Could not locate source for '$1'"
982 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :(" 1027 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
983 1028
984 local shrtsrc="`basename ${src}`" 1029 local shrtsrc=$(basename "${src}")
985 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1030 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
986 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1031 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
987 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1032 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
988 1033
989 # grab metadata for debug reasons 1034 # grab metadata for debug reasons
1053# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1098# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1054# - If the file is not specified then unpack will utilize ${A}. 1099# - If the file is not specified then unpack will utilize ${A}.
1055# - If the offset is not specified then we will attempt to extract 1100# - If the offset is not specified then we will attempt to extract
1056# the proper offset from the script itself. 1101# the proper offset from the script itself.
1057unpack_makeself() { 1102unpack_makeself() {
1103 local src_input=${1:-${A}}
1058 local src="$(find_unpackable_file "$1")" 1104 local src=$(find_unpackable_file "${src_input}")
1059 local skip="$2" 1105 local skip=$2
1060 local exe="$3" 1106 local exe=$3
1061 1107
1108 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1109
1062 local shrtsrc="$(basename "${src}")" 1110 local shrtsrc=$(basename "${src}")
1063 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1111 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1064 if [ -z "${skip}" ] 1112 if [[ -z ${skip} ]] ; then
1065 then
1066 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1113 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1067 local skip=0 1114 local skip=0
1068 exe=tail 1115 exe=tail
1069 case ${ver} in 1116 case ${ver} in
1070 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1117 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1071 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1118 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1083 ;; 1130 ;;
1084 2.1.3) 1131 2.1.3)
1085 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1132 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1086 let skip="skip + 1" 1133 let skip="skip + 1"
1087 ;; 1134 ;;
1088 2.1.4) 1135 2.1.4|2.1.5)
1089 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1136 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1090 skip=$(head -n ${skip} "${src}" | wc -c) 1137 skip=$(head -n ${skip} "${src}" | wc -c)
1091 exe="dd" 1138 exe="dd"
1092 ;; 1139 ;;
1093 *) 1140 *)
1138check_license() { 1185check_license() {
1139 local lic=$1 1186 local lic=$1
1140 if [ -z "${lic}" ] ; then 1187 if [ -z "${lic}" ] ; then
1141 lic="${PORTDIR}/licenses/${LICENSE}" 1188 lic="${PORTDIR}/licenses/${LICENSE}"
1142 else 1189 else
1143 if [ -e "${PORTDIR}/licenses/${src}" ] ; then 1190 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1144 lic="${PORTDIR}/licenses/${src}" 1191 lic="${PORTDIR}/licenses/${lic}"
1145 elif [ -e "${PWD}/${src}" ] ; then 1192 elif [ -e "${PWD}/${lic}" ] ; then
1146 lic="${PWD}/${src}" 1193 lic="${PWD}/${lic}"
1147 elif [ -e "${src}" ] ; then 1194 elif [ -e "${lic}" ] ; then
1148 lic="${src}" 1195 lic="${lic}"
1149 fi
1150 fi 1196 fi
1197 fi
1151 [ ! -f "${lic}" ] && die "Could not find requested license ${src}" 1198 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1152 local l="`basename ${lic}`" 1199 local l="`basename ${lic}`"
1153 1200
1154 # here is where we check for the licenses the user already 1201 # here is where we check for the licenses the user already
1155 # accepted ... if we don't find a match, we make the user accept 1202 # accepted ... if we don't find a match, we make the user accept
1156 local shopts=$- 1203 local shopts=$-
1212 # first we figure out how many cds we're dealing with by 1259 # first we figure out how many cds we're dealing with by
1213 # the # of files they gave us 1260 # the # of files they gave us
1214 local cdcnt=0 1261 local cdcnt=0
1215 local f= 1262 local f=
1216 for f in "$@" ; do 1263 for f in "$@" ; do
1217 cdcnt=$((cdcnt + 1)) 1264 ((++cdcnt))
1218 export CDROM_CHECK_${cdcnt}="$f" 1265 export CDROM_CHECK_${cdcnt}="$f"
1219 done 1266 done
1220 export CDROM_TOTAL_CDS=${cdcnt} 1267 export CDROM_TOTAL_CDS=${cdcnt}
1221 export CDROM_CURRENT_CD=1 1268 export CDROM_CURRENT_CD=1
1222 1269
1223 # now we see if the user gave use CD_ROOT ... 1270 # now we see if the user gave use CD_ROOT ...
1224 # if they did, let's just believe them that it's correct 1271 # if they did, let's just believe them that it's correct
1225 if [[ ! -z ${CD_ROOT} ]] ; then
1226 export CDROM_ROOT=${CD_ROOT}
1227 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1228 return
1229 fi
1230 # do the same for CD_ROOT_X
1231 if [[ ! -z ${CD_ROOT_1} ]] ; then 1272 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1232 local var= 1273 local var=
1233 cdcnt=0 1274 cdcnt=0
1234 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1275 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1235 cdcnt=$((cdcnt + 1)) 1276 ((++cdcnt))
1236 var="CD_ROOT_${cdcnt}" 1277 var="CD_ROOT_${cdcnt}"
1278 [[ -z ${!var} ]] && var="CD_ROOT"
1237 if [[ -z ${!var} ]] ; then 1279 if [[ -z ${!var} ]] ; then
1238 eerror "You must either use just the CD_ROOT" 1280 eerror "You must either use just the CD_ROOT"
1239 eerror "or specify ALL the CD_ROOT_X variables." 1281 eerror "or specify ALL the CD_ROOT_X variables."
1240 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1282 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1241 die "could not locate CD_ROOT_${cdcnt}" 1283 die "could not locate CD_ROOT_${cdcnt}"
1242 fi 1284 fi
1243 export CDROM_ROOTS_${cdcnt}="${!var}"
1244 done 1285 done
1245 export CDROM_ROOT=${CDROM_ROOTS_1} 1286 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1246 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1287 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1288 export CDROM_SET=-1
1289 for f in ${CDROM_CHECK_1//:/ } ; do
1290 ((++CDROM_SET))
1291 [[ -e ${CD_ROOT}/${f} ]] && break
1292 done
1293 export CDROM_MATCH=${f}
1247 return 1294 return
1248 fi 1295 fi
1249 1296
1297 # User didn't help us out so lets make sure they know they can
1298 # simplify the whole process ...
1250 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1299 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1251 einfon "This ebuild will need the " 1300 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1252 if [[ -z ${CDROM_NAME} ]] ; then
1253 echo "cdrom for ${PN}."
1254 else
1255 echo "${CDROM_NAME}."
1256 fi
1257 echo 1301 echo
1258 einfo "If you do not have the CD, but have the data files" 1302 einfo "If you do not have the CD, but have the data files"
1259 einfo "mounted somewhere on your filesystem, just export" 1303 einfo "mounted somewhere on your filesystem, just export"
1260 einfo "the variable CD_ROOT so that it points to the" 1304 einfo "the variable CD_ROOT so that it points to the"
1261 einfo "directory containing the files." 1305 einfo "directory containing the files."
1265 echo 1309 echo
1266 else 1310 else
1267 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1311 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1268 cdcnt=0 1312 cdcnt=0
1269 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1313 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1270 cdcnt=$((cdcnt + 1)) 1314 ((++cdcnt))
1271 var="CDROM_NAME_${cdcnt}" 1315 var="CDROM_NAME_${cdcnt}"
1272 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1316 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1273 done 1317 done
1274 echo 1318 echo
1275 einfo "If you do not have the CDs, but have the data files" 1319 einfo "If you do not have the CDs, but have the data files"
1276 einfo "mounted somewhere on your filesystem, just export" 1320 einfo "mounted somewhere on your filesystem, just export"
1277 einfo "the following variables so they point to the right place:" 1321 einfo "the following variables so they point to the right place:"
1278 einfon "" 1322 einfon ""
1279 cdcnt=0 1323 cdcnt=0
1280 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1324 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1281 cdcnt=$((cdcnt + 1)) 1325 ((++cdcnt))
1282 echo -n " CD_ROOT_${cdcnt}" 1326 echo -n " CD_ROOT_${cdcnt}"
1283 done 1327 done
1284 echo 1328 echo
1285 einfo "Or, if you have all the files in the same place, or" 1329 einfo "Or, if you have all the files in the same place, or"
1286 einfo "you only have one cdrom, you can export CD_ROOT" 1330 einfo "you only have one cdrom, you can export CD_ROOT"
1289 echo 1333 echo
1290 einfo "For example:" 1334 einfo "For example:"
1291 einfo "export CD_ROOT_1=/mnt/cdrom" 1335 einfo "export CD_ROOT_1=/mnt/cdrom"
1292 echo 1336 echo
1293 fi 1337 fi
1338
1339 export CDROM_SET=""
1294 export CDROM_CURRENT_CD=0 1340 export CDROM_CURRENT_CD=0
1295 cdrom_load_next_cd 1341 cdrom_load_next_cd
1296} 1342}
1297 1343
1298# this is only used when you need access to more than one cd. 1344# this is only used when you need access to more than one cd.
1299# when you have finished using the first cd, just call this function. 1345# when you have finished using the first cd, just call this function.
1300# when it returns, CDROM_ROOT will be pointing to the second cd. 1346# when it returns, CDROM_ROOT will be pointing to the second cd.
1301# remember, you can only go forward in the cd chain, you can't go back. 1347# remember, you can only go forward in the cd chain, you can't go back.
1302cdrom_load_next_cd() { 1348cdrom_load_next_cd() {
1303 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1304 local var= 1349 local var
1305 1350 ((++CDROM_CURRENT_CD))
1306 if [[ ! -z ${CD_ROOT} ]] ; then
1307 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1308 return
1309 fi
1310 1351
1311 unset CDROM_ROOT 1352 unset CDROM_ROOT
1312 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1353 var=CD_ROOT_${CDROM_CURRENT_CD}
1354 [[ -z ${!var} ]] && var="CD_ROOT"
1313 if [[ -z ${!var} ]] ; then 1355 if [[ -z ${!var} ]] ; then
1314 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1356 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1315 cdrom_locate_file_on_cd ${!var} 1357 _cdrom_locate_file_on_cd ${!var}
1316 else 1358 else
1317 export CDROM_ROOT=${!var} 1359 export CDROM_ROOT=${!var}
1318 fi 1360 fi
1319 1361
1320 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1362 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1325# all it does is try to locate a give file on a cd ... if the cd isn't 1367# all it does is try to locate a give file on a cd ... if the cd isn't
1326# found, then a message asking for the user to insert the cdrom will be 1368# found, then a message asking for the user to insert the cdrom will be
1327# displayed and we'll hang out here until: 1369# displayed and we'll hang out here until:
1328# (1) the file is found on a mounted cdrom 1370# (1) the file is found on a mounted cdrom
1329# (2) the user hits CTRL+C 1371# (2) the user hits CTRL+C
1330cdrom_locate_file_on_cd() { 1372_cdrom_locate_file_on_cd() {
1373 local mline=""
1374 local showedmsg=0
1375
1331 while [[ -z ${CDROM_ROOT} ]] ; do 1376 while [[ -z ${CDROM_ROOT} ]] ; do
1377 local i=0
1378 local -a cdset=(${*//:/ })
1379 if [[ -n ${CDROM_SET} ]] ; then
1380 cdset=(${cdset[${CDROM_SET}]})
1381 fi
1382
1383 while [[ -n ${cdset[${i}]} ]] ; do
1332 local dir="$(dirname ${@})" 1384 local dir=$(dirname ${cdset[${i}]})
1333 local file="$(basename ${@})" 1385 local file=$(basename ${cdset[${i}]})
1334 local mline=""
1335 local showedmsg=0
1336 1386
1337 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1387 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1338 [[ -d ${mline}/${dir} ]] || continue 1388 [[ -d ${mline}/${dir} ]] || continue
1339 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \ 1389 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1340 && export CDROM_ROOT=${mline} 1390 export CDROM_ROOT=${mline}
1391 export CDROM_SET=${i}
1392 export CDROM_MATCH=${cdset[${i}]}
1393 return
1394 fi
1395 done
1396
1397 ((++i))
1341 done 1398 done
1342 1399
1343 if [[ -z ${CDROM_ROOT} ]] ; then
1344 echo 1400 echo
1345 if [[ ${showedmsg} -eq 0 ]] ; then 1401 if [[ ${showedmsg} -eq 0 ]] ; then
1346 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1402 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1347 if [[ -z ${CDROM_NAME} ]] ; then 1403 if [[ -z ${CDROM_NAME} ]] ; then
1348 einfo "Please insert the cdrom for ${PN} now !" 1404 einfo "Please insert+mount the cdrom for ${PN} now !"
1349 else
1350 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1351 fi
1352 else 1405 else
1353 if [[ -z ${CDROM_NAME_1} ]] ; then
1354 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1355 else
1356 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1357 einfo "Please insert+mount the ${!var} cdrom now !" 1406 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1358 fi
1359 fi 1407 fi
1360 showedmsg=1 1408 else
1409 if [[ -z ${CDROM_NAME_1} ]] ; then
1410 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1411 else
1412 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1413 einfo "Please insert+mount the ${!var} cdrom now !"
1414 fi
1361 fi 1415 fi
1416 showedmsg=1
1417 fi
1362 einfo "Press return to scan for the cd again" 1418 einfo "Press return to scan for the cd again"
1363 einfo "or hit CTRL+C to abort the emerge." 1419 einfo "or hit CTRL+C to abort the emerge."
1364 echo 1420 echo
1365 einfo "If you are having trouble with the detection" 1421 einfo "If you are having trouble with the detection"
1366 einfo "of your CD, it is possible that you do not have" 1422 einfo "of your CD, it is possible that you do not have"
1367 einfo "Joliet support enabled in your kernel. Please" 1423 einfo "Joliet support enabled in your kernel. Please"
1368 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1424 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1369 read 1425 read
1370 fi
1371 done 1426 done
1372} 1427}
1373 1428
1374# Make sure that LINGUAS only contains languages that 1429# Make sure that LINGUAS only contains languages that
1375# a package can support 1430# a package can support
1496 LIB=$1 1551 LIB=$1
1497 1552
1498 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1553 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then
1499 SONAME=`basename ${LIB}` 1554 SONAME=`basename ${LIB}`
1500 1555
1501 einfo "An old version of an installed library was detected on your system." 1556 ewarn "An old version of an installed library was detected on your system."
1502 einfo "In order to avoid breaking packages that link against it, this older version" 1557 ewarn "In order to avoid breaking packages that link against it, this older version"
1503 einfo "is not being removed. In order to make full use of this newer version," 1558 ewarn "is not being removed. In order to make full use of this newer version,"
1504 einfo "you will need to execute the following command:" 1559 ewarn "you will need to execute the following command:"
1505 einfo " revdep-rebuild --soname ${SONAME}" 1560 ewarn " revdep-rebuild --soname ${SONAME}"
1506 einfo 1561 ewarn
1507 einfo "After doing that, you can safely remove ${LIB}" 1562 ewarn "After doing that, you can safely remove ${LIB}"
1508 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild" 1563 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1509 fi 1564 fi
1510} 1565}
1511 1566
1512# Hack for people to figure out if a package was built with 1567# Hack for people to figure out if a package was built with
1513# certain USE flags 1568# certain USE flags
1523 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1578 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1524 1579
1525 local PKG=$(best_version $1) 1580 local PKG=$(best_version $1)
1526 shift 1581 shift
1527 1582
1528 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1583 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1584
1585 # if the USE file doesnt exist, assume the $PKG is either
1586 # injected or package.provided
1529 [[ ! -e ${USEFILE} ]] && return 1 1587 [[ ! -e ${USEFILE} ]] && return 0
1530 1588
1531 local USE_BUILT=$(<${USEFILE}) 1589 local USE_BUILT=$(<${USEFILE})
1532 while [[ $# -gt 0 ]] ; do 1590 while [[ $# -gt 0 ]] ; do
1533 if [[ ${opt} = "-o" ]] ; then 1591 if [[ ${opt} = "-o" ]] ; then
1534 has $1 ${USE_BUILT} && return 0 1592 has $1 ${USE_BUILT} && return 0
1586# $4 == extra LD_LIBRARY_PATH's (make it : delimited) 1644# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1587# $5 == path for wrapper 1645# $5 == path for wrapper
1588make_wrapper() { 1646make_wrapper() {
1589 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1647 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1590 local tmpwrapper=$(emktemp) 1648 local tmpwrapper=$(emktemp)
1649 # We don't want to quote ${bin} so that people can pass complex
1650 # things as $bin ... "./someprog --args"
1591 cat << EOF > "${tmpwrapper}" 1651 cat << EOF > "${tmpwrapper}"
1592#!/bin/sh 1652#!/bin/sh
1593cd "${chdir}" 1653cd "${chdir:-.}"
1654if [ -n "${libdir}" ] ; then
1655 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1594export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1656 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1657 else
1658 export LD_LIBRARY_PATH="${libdir}"
1659 fi
1660fi
1595exec ${bin} "\$@" 1661exec ${bin} "\$@"
1596EOF 1662EOF
1597 chmod go+rx "${tmpwrapper}" 1663 chmod go+rx "${tmpwrapper}"
1598 if [ -n "${5}" ] 1664 if [[ -n ${path} ]] ; then
1599 then
1600 exeinto ${5} 1665 exeinto "${path}"
1601 newexe "${tmpwrapper}" "${wrapper}" 1666 newexe "${tmpwrapper}" "${wrapper}"
1602 else 1667 else
1603 newbin "${tmpwrapper}" "${wrapper}" 1668 newbin "${tmpwrapper}" "${wrapper}"
1604 fi 1669 fi
1605} 1670}

Legend:
Removed from v.1.187  
changed lines
  Added in v.1.218

  ViewVC Help
Powered by ViewVC 1.1.20